<?php

/*
    This file is part of Spip-clone.

    Spip-clone is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Spip-clone is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Trad-Lang; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Copyright 2004
		Mathieu Lutfy <mathieu@bidon.ca>

	$Id: inc_clones.php,v 1.2 2004/11/06 10:34:52 bgm Exp $
*/

if (defined("_INC_CLONES")) return;
define("_INC_CLONES", "1");

// Installation ou reconfiguration de spip-clône
function config_globale($etape = "") {
	global $pgm_nom;
	global $pgm_version;

	// Si formulaire
	global $conf_spipcore;
	global $conf_spipsquels;
	global $conf_type_serveur;
	global $conf_mes_fonctions;
	global $conf_mes_options;

	// si type install est admin + sudo
	global $conf_vhostsbase;
	global $conf_httpdconf;

	$erreurs = 0;

	if ($etape == "reconf")
		$erreurs++;

	if (! $conf_spipcore)
		$erreurs++;

	if (! $conf_spipsquels)
		$erreurs++;

	if (! $conf_type_serveur)
		$erreurs++;

	if (! $erreurs) {
		// Écrire le fichier de conf
		$nom_fichier = 'spip_clone/data/inc_conf.php';
		$texte = "<?php\n" . '
			$conf_spipcore = "' . $conf_spipcore . '";
			$conf_spipsquels = "' . $conf_spipsquels . '";
			$conf_type_serveur = "' . $conf_type_serveur . '";
			
			$conf_mes_fonctions = "' . addslashes($conf_mes_fonctions) . '";
			$conf_mes_options = "' . addslashes($conf_mes_options) . '";
		';

		if ($conf_vhostsbase)
			$texte .= '$conf_vhostsbase = "' . $conf_vhostsbase . '";' . "\n";

		if ($conf_httpdconf)
			$texte .= '$conf_httpdconf = "' . $conf_httpdconf . '";' .  "\n";

		$texte .= '$conf_version_spipclone = ' . $pgm_version . ';' . "\n";
		$texte .= "\n?>";
		
		$fconf = fopen($nom_fichier, "w");
		if ($fconf) {
			fwrite($fconf, $texte);
			fclose($fconf);
		
			$message = "<p><b>Configuration enregistrée.</b><br />"
				. "<a href='spip_clone.php'>Retourner à la page d'accueil?</a></p>";
		} else {
			$message = "<p>Le fichier " . $nom_fichier . " ne peut être ouvert.</p>";
		}

		// header("Location: spip_clone.php?privet=da");
		// exit;
	}

	html_tete($pgm_nom . " - Installation");

	debut_html_form("form_install", "post", "installation");

	if ($message)
		echo $message;

	echo "<h3>Source SPIP: </h3>\n";
	echo "<blockquote>La source SPIP est votre r&eacute;pertoire o&ugrave;
		vous avez d&eacute;compatact&eacute; SPIP. Id&eacute;alement, ce SPIP
		n'est pas install&eacute; et sert que de r&eacute;f&eacute;rence pour
		les cl&ocirc;nes SPIP qui seront cr&eacute;&eacute;s. Le chemin peut
		&ecirc;tre absolu (<tt>/home/.../spip/</tt>) ou relatif
		(<tt>../spip_core/</tt>) par rapport à <tt>" . getcwd() . "</tt>."
		. "</blockquote>\n";

	if (! $conf_spipcore)
		$conf_spipcore = getcwd() . "/spip_core/";

	echo "<div align='center'>" 
		. get_html_form_item("text", "conf_spipcore", $conf_spipcore, "size='50'") 
		. "</div>\n";

	echo "<h3>Répertoire des squelettes: </h3>\n";
	echo "<blockquote>Si un r&eacute;pertoire de squelettes est
		sp&eacute;cifi&eacute;, " . $pgm_nom . " cherchera dans ce
		r&eacute;pertoire pour une liste de squelettes qui pourront
		&ecirc;tre sp&eacute;cifi&eacute;s lors de la cr&eacute;ation
		d'un nouveau cl&ocirc;ne. Si laiss&eacute; vide, le squelette
		par d&eacute;faut de Spip sera utilis&eacute;.</blockquote>\n";

	if (! $conf_spipsquels) 
		$conf_spipsquels = getcwd() . "/spip_squels/";

	echo "<div align='center'>"
		. get_html_form_item("text", "conf_spipsquels", $conf_spipsquels, "size='50'")
		. "</div>\n";

	echo "<h3>Contenu par défaut de mes_functions.php3</h3>\n";
	echo "<blockquote>Si vous placez des informations dans cette boîte,
		son contenu sera proposé pour être inclu dans le fichier
		mes_functions.php3 d'un site lors de sa création. Ceci est sans 
		effet sur les sites existants.</blockquote>\n";
		
	echo "<textarea name='conf_mes_fonctions' id='conf_mes_fonctions' rows='4' cols='65' wrap=soft>";
	if ($conf_mes_fonctions) {
		echo $conf_mes_fonctions;
	} else {
		echo "// par exemple, on peut faire un include pour éviter de\n";
		echo "// faire une mise à jour de ce fichier à tous les coups.\n";
		echo "// include('mes_fonctions_communes.php3');\n";
	}
	echo "</textarea>\n";
	echo "<p style='font-size:70%;'>Note: Ne pas ajouter les &lt;?php ..  ?&gt;</p>\n";

	echo "<h3>Contenu par défaut de ecrire/mes_options.php3</h3>\n";
	echo "<blockquote>Si vous placez des informations dans cette boîte,
		son contenu sera proposé pour être inclu dans le fichier
		ecrire/mes_functions.php3 d'un site lors de sa création. Ceci 
		est sans effet sur les sites existants.</blockquote>\n";
		
	echo "<textarea name='conf_mes_options' id='conf_mes_options' rows='4' cols='65' wrap='soft'>";
	if ($conf_mes_options) {
		echo $conf_mes_options;
	} else {
		echo "// par exemple:\n";
		echo "// ?\n";
	}
	echo "</textarea>\n";
	echo "<p style='font-size:70%;'>Note: Ne pas ajouter les &lt;?php ..  ?&gt;</p>\n";

	echo "<h3>Type de serveur multi-site</h3>\n";

	echo "<ul>";
	echo "<li style='list-style-type: none;'>"
		. "<input type='radio' checked='checked' name='conf_type_serveur' id='conf_type_serveur_1' value='uni_user'>"
		. "<label for='conf_type_serveur_1'>Un seul utilisateur a acc&egrave;s par
			FTP/SFTP aux squelettes (<b>en cas de doute, utiliser cette option</b>).</label>"
		. "</li>\n";
	echo "<li style='list-style-type: none;'>"
		. "<input type='radio' name='conf_type_serveur' id='conf_type_serveur_2' value='multi_user'>"
		. "<label for='conf_type_serveur_2'>Chaque administrateur des multi-sites
			peut modifier ses squelettes par FTP/SFTP (si vous avez le droit de
			cr&eacute;er de nouveaux comptes utilisateurs sur ce serveur).</label>
		. </li>\n";
	echo "</ul>\n";

	echo "<h3>Destination des multi-sites: </h3>\n";
	echo "<blockquote><strong>Ignorer</strong> si vous avez coch&eacute; la 1re "
		. "option ci-dessus.</blockquote>\n";
	echo "<div align='center'>" 
		. get_html_form_item("text", "conf_vhostsbase", get_vhostdocroot(), "size='50'") 
		. "</div>\n";

	echo "<h3>Fichier de configuration d'Apache: </h3>\n";
	echo "<blockquote><strong>Ignorer</strong> si vous avez coch&eacute; la 1re "
		. "option ci-dessus.</blockquote>\n";
	echo "<div align='center'>"
		. get_html_form_item("text", "conf_httpdconf", get_httpdconf(), "size='50'") 
		. "</div>\n";

	markup("p", get_html_form_item("submit", "submit_valider", "Valider"), "", "text-align: center;");

	fin_html_form();

	html_pied();
}

function get_clone($nom) {
	global $conf_dir_clones;
	$ret = array();

	$nom = nettoyer_varsimple($nom);

	if (! $nom) {
		msg_erreur("Bad function call to get_clone().");
		exit;
	}

	$nom = "clone_" . $nom . ".php";
	$nom_fichier = $conf_dir_clones . "/" . $nom;

	if (is_file($nom_fichier)) {
		if (!ereg("^clone_(.+)\.php$", $nom, $extlg)) {
			msg_erreur("Bad function call to get_clone().");
			exit;
		}

		include($nom_fichier);

		// ajoute "clone_site_nom, clone_site_url, ..."
		while (list($idl, $val) = each($clone)) {
			$ret[$idl] = $val;
		}
	} else {
		msg_erreur("Le fichier " . $nom_fichier . " n'existe pas.");
		exit;
	}

	return $ret;
}

function get_all_clones() {
	global $conf_dir_clones;
	$ret = array();

	$handle = opendir($conf_dir_clones);
	while (($fichier = readdir($handle)) != '') {
		// Eviter ".", "..", ".htaccess", etc.
		if ($fichier[0] == '.') continue;
		if ($fichier == 'CVS') continue;

		$nom_fichier = $conf_dir_clones . "/" . $fichier;

		if (is_file($nom_fichier)) {
			if (!ereg("^clone_(.+)\.php$", $fichier, $extlg))
				continue;

			include($nom_fichier);
			$ret[$extlg[1]]["fichier"] = $nom_fichier;

			while (list($idl, $val) = each($clone)) {
				// ajoute "clone_site_nom, clone_site_url, ..."
				$ret[$extlg[1]][$idl] = $val;
			}
		}
    }

	closedir($handle);
	return $ret;
}

function creer_nom_unique_fichier_clone($site_url) {
	global $conf_dir_clones; 

	$nom_fichier = strtolower($site_url);
	$nom_fichier = ereg_replace("http://", "", $nom_fichier);
	$nom_fichier = ereg_replace("\.", "_", $nom_fichier);
	$nom_fichier = ereg_replace("/", "_", $nom_fichier);
	$nom_fichier = ereg_replace("_$", "", $nom_fichier); // si non se termine par /
	$nom_fichier = nettoyer_varsimple($nom_fichier);

	$cpt_bis = "";
	while (is_file($conf_dir_clones . "/clone_" . $nom_fichier . $cpt_bis . ".php"))
		$cpt_bis = $cpt_bis + 1;

	// $nom_fichier_complet = $conf_dir_clones . "/" . "clone_" . $nom_fichier . $cpt_bis . ".php";
	return "clone_" . $nom_fichier . $cpt_bis . ".php";
}

// Supprimer les liens symboliques qui n'ont pas la même destionation
// puis créer un nouveau lien si nécessaire
function my_symlink($target, $link) {
	if (@is_link($link)) {
		$link_dest = readlink($link);

		if ($link_dest == $target) {
			return true;
		} else {
			// XXX If we cannot unlink, it could create a mess..
			$res = unlink($link);
			if (! $res) return false;
		}
	}

	return symlink($target, $link);
}

function my_mkdir($dir) {
	if (! is_dir($dir))
		return mkdir($dir);
	else
		return true;
}

function ajout_log(& $log, $res, $texte) {
	// D = debug, A = avertissement
	// array_push($log, ($res ? "D: " : "A: ") . $texte);
	$log[] = ($res ? "D: " : "A: ") . $texte;
}

function creer_milliers_liens_symboliques($dir_core, $dir_clone, $base = "", $log = array()) {
	// TODO:
	// - Spip 1.8 > 1.808: Ne pas créer de symlink pour fichiers
	//  ecrire/inc_* (sauf version et lab) ?

	umask("0022");
	clearstatcache();

	$dir_core = preg_replace("/\/$/", "", $dir_core);
	$dir_clone = preg_replace("/\/$/", "", $dir_clone);

	$handle = opendir($dir_core . $base);
	
	while (($fichier = readdir($handle)) != '') {
		// Eviter ".", "..", "CVS", mais pas ".htaccess", etc.
		if ($fichier == '.') continue;
		if ($fichier == '..') continue;
		if ($fichier == 'CVS') continue;

		if (is_file($dir_core . $base . '/' . $fichier)) {
			if ('/ecrire/inc_connect.php3' == $base . $fichier) {
				ajout_log($log, true, "inc_connect.php3 ignoré");
				continue;
			}

			// Create symlink
			$res = my_symlink($dir_core . $base . '/' . $fichier,
							$dir_clone . $base . '/' . $fichier);

			ajout_log($log, $res, "symlink: " . $base . '/' . $fichier);
			// array_push($log, "symlink " . $base . '/' . $fichier . " = " .  $res);
		} else if (is_dir($dir_core . $base . '/' . $fichier)) {
			if ('CACHE' == $base . $fichier) {
				// mkdir
				$res = my_mkdir($dir_clone . "/" . $fichier);
				ajout_log($log, $res, "mkdir: " . $fichier);
			} else if ('/ecrire/upload' == $base . $fichier) {
				// mkdir
				$res = my_mkdir($dir_clone . "/" . $fichier);
				ajout_log($log, $res, "mkdir: " . $fichier);
			} else if ('/ecrire/data' == $base . $fichier) {
				// mkdir
				$res = my_mkdir($dir_clone . "/" . $fichier);
				ajout_log($log, $res, "mkdir: " . $fichier);
			} else if ('/ecrire/img_pack' == $base . $fichier) {
				// ln vers la destination
				$res = my_symlink($dir_core . '/' . $base . '/' . $fichier,
								$dir_clone . '/' . $base . '/' . $fichier);
				ajout_log($log, $res, "symlink: " . $base . $fichier);
			} else if ('/ecrire/AIDE' == $base . $fichier) {
				// ln vers la destination
				$res = my_symlink($dir_core . '/' . $base . '/' . $fichier,
								$dir_clone . '/' . $base . '/' . $fichier);
				ajout_log($log, $res, "symlink: " . $base . $fichier);
			} else if ('/IMG/icones_barre' == $base . $fichier) {
				// ln vers la destination
				$res = my_symlink($dir_core . '/' . $base . '/' . $fichier,
								$dir_clone . '/' . $base . '/' . $fichier);
				ajout_log($log, $res, "symlink: " . $base . $fichier);
			} else if ('/spip_clone' == $base . $fichier) {
				// ignorer
				ajout_log($log, true, "j'ignore " . $fichier);
			} else if ('/trad-lang' == $base . $fichier) {
				// ignorer
				ajout_log($log, true, "j'ignore " . $fichier);
			} else {
				$res = my_mkdir($dir_clone . $base . '/' . $fichier);
				ajout_log($log, $res, "mkdir: " . $base . '/' . $fichier);
				ajout_log($log, true, "** J'entre dans " . $base . '/' .  $fichier);

				$log = creer_milliers_liens_symboliques($dir_core, $dir_clone, $base . '/' . $fichier, $log);
				ajout_log($log, true, "** Je suis sorti de " . $base . '/' .  $fichier);
			}
		} else {
			ajout_log($log, false, "(!) Ni fichier ni répertoire? " . $dir_core . $base .  '/' . $fichier);
		}
	}

	return $log;
}

// Vivement les noms de fonctions à n'en plus finir
function ecrire_fichier_php_si_possible($nom, $texte, & $log) {
	if (! is_file($nom)) {
		$fd = fopen($nom, 'w');
		if ($fd) {
			fwrite($fd, "<?php\n");
			fwrite($fd, $texte);
			fwrite($fd, "\n?>\n");
			fclose($fd);
			ajout_log($log, true, "$nom: Fichier créé");
		} else {
			ajout_log($log, false, "$nom: Impossible d'ouvrir le fichier en écriture");
		}
	} else {
		ajout_log($log, false, "$nom: Le fichier existe, je n'y touche pas");
	}

	return $log;
}

function details_clone($clone = "") {
	echo "<h3>"
		. "Informations g&eacute;n&eacute;rales"
		. ($clone['clone_site_nom'] ? " - " . $clone['clone_site_nom'] : '');
	echo "</h3>\n";

	echo "<table border='0' width='100%' cellpadding='1' cellspacing'1'>\n";
	echo "<tr>\n";
		html_td("Nom site:");

		if ($clone['clone_site_nom'])
			html_td($clone['clone_site_nom']);
		else
			html_td(get_html_form_item("text", "site_nom", "", "size='25'"));
	echo "</tr><tr>\n";
		html_td("Adresse:");
		
		if ($clone['clone_site_url'])
			html_td("<a href='" . $clone['clone_site_url'] . "'>" . $clone['clone_site_url'] . "</a>");
		else
			html_td(get_html_form_item("text", "site_url", "http://", "size='25'"));
	echo "</tr><tr>\n";
		html_td("Auteur:");

		if ($clone['clone_contact_nom'])
			html_td($clone['clone_contact_nom']);
		else
			html_td(get_html_form_item("text", "contact_nom", "", "size='25'"));
	echo "</tr><tr>\n";
		html_td("Courriel:");

		if ($clone['clone_contact_courriel'])
			html_td("<a href='mailto:" . $clone['clone_contact_courriel'] 
							. "'>" . $clone['clone_contact_courriel'] . "</a>");
		else
			html_td(get_html_form_item("text", "contact_courriel", "", "size='25'"));
	echo "</tr><tr>\n";
		html_td("<h3>Dates</h3>", "left", 2);
	echo "</tr><tr>\n";
		html_td("<blockquote>Ces dates sont symboliques. Si la date 
			d'expiration ne vous intéresse pas, vous pouvez entrer 
			celle de l'expiration du nom de domaine, une information
			souvent oubliée.</blockquote>", "left", 2);
	echo "</tr><tr>\n";
		html_td("Date de création:");

		if ($clone['clone_date_creation']) {
			html_td($clone['clone_date_creation'] . "&nbsp;&nbsp; Date d'expiration: " . $clone['clone_date_expiration']);
		} else {
			$my_date = date("Y-m-d", time());
			$my_date2 = date("Y-m-d", date_add('a', 1, time()));
			html_td(get_html_form_item("text", "date_creation", $my_date, "size='10'")
					. "&nbsp;&nbsp;Expiration: " 
					. get_html_form_item("text", "date_expiration", $my_date2, "size='10'"));
		}
	echo "</tr><tr>\n";
		html_td("<h3>Création du clône</h3>", "left", 2);
	echo "</tr><tr>\n";
		html_td("<blockquote>La source est généralement accessible qu'en
			lecture seule et n'est pas utilisée par un site web.  La destination
			est le chemin d'accès vers la racine de l'hébergé.</blockquote>\n",
			"left", 2);
	echo "</tr><tr>\n";
		html_td("Source:");

		if ($clone['clone_path_src'])
			html_td($clone['clone_path_src']);
		else
			html_td(get_html_form_item("text", "path_src", $conf_spipcore, "size='45'"));

	echo "</tr><tr>\n";
		echo "<input type='hidden' name='vhostdocroot' value='" . get_vhostdocroot() . "'/>\n";
		html_td("Destination:");

		if ($clone['clone_path_dest']) {
			html_td($clone['clone_path_dest']);
		} else {
			if ($conf_type_serveur == 'multi_user')
				html_td(get_html_form_item("text", "path_dest", $conf_vhostsbase . " ...", "size='45'"));
			else
				html_td(get_html_form_item("text", "path_dest", getcwd() . "/ ...", "size='45'"));
		}
	if (! $clone) {
		echo "</tr><tr>\n";
			html_td("Exécution détaillée:");
			$debug_opt = array();
			$debug_opt[0] = "non (normal)";
			$debug_opt[1] = "oui (en cas de problème)";
			html_td(get_html_select("select_debug", $debug_opt));
	}
	echo "</tr><tr>\n";
		html_td("<blockquote>Le répertoire des squelettes sera 'squelettes' et
			un fichier <tt>mes_fonction.php3</tt> sera créé en conséquence.
			<B>Note&nbsp;:</B> Si un fichier mes_fonctions.php3 existe déjà, il
			ne sera pas modifié.</blockquote>", "left", 2);
	echo "</tr><tr>\n";
		html_td("Squelette:");

		if ($clone['clone_squelette'])
			html_td($clone['clone_squelette']);
		else
			html_td(get_html_select("select_squelettes", get_squels()));

	echo "</tr><tr>\n";
		html_td("<h3>mes_fonctions.php3</h3>", "left", 2);
	echo "</tr><tr>\n";
		html_td("<blockquote>Aperçu du fichier <tt>mes_fonctions.php3</tt>,
			vous pouvez y ajouter des informations selon vos besoins, mais il
			est fortement suggéré de ne rien enlever!</blockquote>", "left", 2);
	echo "</tr><tr>\n";
		if ($clone) {
			$nom_fichier = $clone['clone_path_dest'] .  "/mes_fonctions.php3";
			if (is_file($nom_fichier)) {
				$fmesfonctions = fopen($nom_fichier, "r");
				if ($fmesfonctions) {
					$texte_mes_fonctions = fread($fmesfonctions, filesize($nom_fichier));
					$texte_mes_fonctions = ereg_replace("\t", "  ", $texte_mes_fonctions);
					html_td("<textarea disabled='disabled' name='mes_fonctions' rows='4' cols='65' wrap='soft'>" . $texte_mes_fonctions . "</textarea>", "left", 2);
				} else {
					html_td("<textarea disabled='disabled' name='mes_fonctions' rows='4' cols='65' wrap='soft'>Le fichier ne peut pas être ouvert en lecture.</textarea>", "left", 2);
				}
			} else {
				html_td("<textarea disabled='disabled' name='mes_fonctions' rows='4' cols='65' wrap='soft'>Le fichier n'existe pas.</textarea>", "left", 2);
			}
		} else {
			html_td("<textarea name='mes_fonctions' rows='4' cols='65' wrap='soft'>"
				. $conf_mes_fonctions . "\n"
				. '$GLOBALS[\'dossier_squelettes\'] = \'squelettes\';'
				. "</textarea>\n"
				. "<p class='petit'>Note: Ne pas ajouter les &lt;?php .. ?&gt;</p>",
				"left", 2);
		}
	echo "</tr><tr>\n";
		html_td("<h3>ecrire/mes_options.php3</h3>", "left", 2);
	echo "</tr><tr>\n";

	if (! $clone) {
		html_td("<blockquote>Vous pouvez utiliser un différent préfixe
			pour la base de données. Ceci est particulièrement utile si vous
			hébergez plusieurs SPIPs dans la même base MySQL. <B>Note:</B> S'il y a
			déjà un fichier mes_options.php3, il sera conservé.</blockquote>",
			"left", 2);
		echo "</tr><tr>\n";
	}

	if ($clone) {
		html_td("<blockquote>Ce fichier est affiché que pour votre
				curiosité. Dans le cas le plus normal, il est vide, mais il est
				possible d'y insérer un \"préfixe\" pour installer plusieurs SPIPs
				dans la même base MySQL.</blockquote>", "centre", 2);
		echo "</tr><tr>\n";
		$nom_fichier = $clone['clone_path_dest'] .  "/ecrire/mes_options.php3";
		if (is_file($nom_fichier)) {
			$fmesoptions = fopen($nom_fichier, "r");
			if ($fmesoptions) {
				$texte_mes_options = fread($fmesoptions, filesize($nom_fichier));
				$texte_mes_options = ereg_replace("\t", "  ", $texte_mes_options);
				html_td("<textarea disabled='disabled' name='mes_options' rows='4' cols='65' wrap='soft'>" . $texte_mes_options . "</textarea>", "left", 2);
			} else {
				html_td("<textarea disabled='disabled' name='mes_options' rows='4' cols='65' wrap='soft'>Le fichier ne peut pas être ouvert en lecture.</textarea>", "left", 2);
			}
		} else {
			html_td("<textarea disabled='disabled' name='mes_options' rows='4' cols='65' wrap='soft'>Le fichier n'existe pas.</textarea>", "left", 2);
		}
	} else {
		html_td("Préfixe:");
		html_td("<input
			onChange='prefixeBD2options(document.form_creer.db_prefix.value, document.form_creer.mes_options_prefixe);'
			onBlur='prefixeBD2options(document.form_creer.db_prefix.value, document.form_creer.mes_options_prefixe);'
			onKeyUp='prefixeBD2options(document.form_creer.db_prefix.value, document.form_creer.mes_options_prefixe);'
			type='text' name='db_prefix' value='' size='5'> (optionnel)");
	echo "</tr><tr>\n";
		html_td("<textarea name='mes_options_prefixe' rows='2' cols='65' wrap='soft'>"
			. "</textarea>"
			. "<p class='petit'>Note: Ne pas ajouter les &lt;?php ..  ?&gt;</p>", "left", 2);
	echo "</tr><tr>\n";
		html_td("<textarea name='mes_options_reste' rows='4' cols='65' wrap='soft'>"
			. $conf_mes_options . "\n"
			. "</textarea>"
			. "<p class='petit'>Note: Ne pas ajouter les &lt;?php ..  ?&gt;</p>", "left", 2);
	}

	if (! $clone) {
		echo "</tr><tr>\n";
		html_td("<h3>Création automatique de mots-clés et rubriques</h3>", "left", 2);
		echo "</tr><tr>\n";
		html_td("<blockquote>TODO: Pour le moment, des mots-clés peuvent être
			créés dans une étape à part à partir de l'écran de bienvenue de
			spip-clône. La création automatique de rubrique n'est pas encore
			disponible.</blockquote>", "left", 2);
	}

	echo "</tr><tr>\n";
		html_td("<h3>Notes optionnelles</h3>", "left", 2);
	echo "</tr><tr>\n";
		html_td("<blockquote>Vous pouvez ajouter des notes au sujet de cette 
			installation, pour utilisation personnelle.</blockquote>", "left", 2);
	echo "</tr><tr>\n";

	html_td("<textarea name='clone_notes' rows='4' cols='65' wrap='soft'>"
		. $clone['clone_notes']
		. "</textarea>", "left", 2);

	echo "</tr><tr>\n";
		html_td("<input type='submit' value='Valider' name='Valider'>", "right", 2);
	echo "</tr>\n";
	echo "</table>\n";
}

?>
