<?php

/*
    This file is part of Spip-clone.

    Spip-clone is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Spip-clone is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Trad-Lang; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Copyright 2004
		Mathieu Lutfy <mathieu@bidon.ca>

	$Id: spip_clone.php,v 1.13 2004/11/06 10:36:19 bgm Exp $
*/

// N.B. Ce fichier est encodé en Unicode UTF-8
// N.B. This file is Unicode UTF-8 encoded

/* ------------------------------------------------------------------------- *
 * Configuration pour l'installation compliquée seulement                    *
 * Configuration for the complicated installation only                       *
 * ------------------------------------------------------------------------- */

// If no unixowner, it will be the user running the script
// (This will probably be 'apache'. Not the best, but it works.)
$conf_unixowner = "";

/* ------------------------------------------------------------------------- *
 * PROGRAMME - Ne pas toucher! - Do not touch!                               *
 * ------------------------------------------------------------------------- */
$pgm_nom = "Spip-Clone";
$pgm_version = "0.31";
$conf_dir_clones = "spip_clone/data";

ini_set(memory_limit, "32M");

$home = "..";
chdir($home);

//
// Si SPIP installé + configuré, on l'utilise pour vérifier
// l'accès à ce script. Sinon, on ne fait pas d'authentification
// du tout, car on tombe dans le problème de l'oeuf ou la poule..
//
$spip_actif = (file_exists("ecrire/inc_connect.php3"));
if ($spip_actif) {
	include("ecrire/inc_version.php3");
	include_ecrire('inc_session.php3');

	verifier_visiteur();
	
	if (!$auteur_session) {
		header("Location: ../spip_login.php3?var_url=spip_clone%2Fspip_clone.php");
		exit;
	}
	
	if (! $auteur_session['statut'] == '0minirezo') {
		echo "<P>Vous n'&ecirc;tes pas admin - acc&agrave;s refus&eacute;</P>\n";
		exit;
	}
}

/* ------------------------------------------------------------------------- *
 * FONCTIONS                                                                 *
 * ------------------------------------------------------------------------- */

// Utilisation douteuse
function get_httpdconf() {
	global $conf_apacheconf;

	if ($conf_apacheconf) {
		$conffile = $conf_apacheconf;
	} else {
		if (@file_exists("/etc/httpd/conf/httpd.conf")) {
			$conffile = "/etc/httpd/conf/httpd.conf";
		} else if (@file_exists("/etc/httpd/httpd.conf")) {
			$conffile = "/etc/httpd/httpd.conf";
		} else if (@file_exists("/etc/apache/conf/httpd.conf")) {
			$conffile = "/etc/apache/conf/httpd.conf";
		} else if (@file_exists("/etc/apache/httpd.conf")) {
			$conffile = "/etc/apache/httpd.conf";
		} else {
			return "";
		}
	}

	return $conffile;
}

// Utilisation douteuse
function get_vhostdocroot() {
	$conffile = get_httpdconf();
	if (!$conffile) return "";

	$vhostdocroot = shell_exec("grep VirtualDocumentRoot " . $conffile . " | awk '{print $2};' | uniq | head -1");

	return ereg_replace("\n", "", $vhostdocroot);
}

function msg_erreur($texte) {
	global $pgm_nom;
	global $pgm_version;

	echo "<p><p>ERREUR</b>: " . $pgm_nom . " (v" . $pgm_version . ") / " . $texte . "</p>\n";
}

include('inc/inc_bazar.php'); // bric à brac de fonctions
include('inc/inc_clones.php'); // fonctions aides pour manipuler les clônes

/*
   ----------------------------------------------------------------
   ETAPES
   ----------------------------------------------------------------
*/

if (!@file_exists('spip_clone/data/inc_conf.php')) {
	include('inc/inc_clones.php');
	config_globale();
	exit;
}

// ne doit pas lire la conf de inc_conf, mais les params
if ($etape == "installation") {
	include('inc/inc_clones.php');
	config_globale($etape);
	exit;
}

include('data/inc_conf.php');

if ($etape == "reconf") {
	include('inc/inc_clones.php');
	config_globale($etape);
	exit;
}

if ($conf_version_spipclone < $pgm_version) {
	include('inc/inc_clones.php');
	config_globale();
	exit;
}

if (! $etape) {
	html_tete($pgm_nom . " / Choisir une action:");

	echo "<ul>";
	echo "<li><a href='". $PHP_SELF ."?etape=creer'>Cr&eacute;er un nouveau site sous SPIP</a></li>\n";
	echo "<li><a href='". $PHP_SELF ."?etape=maj'>Acc&eacute;der au panneau des mises &agrave; jour</a></li>\n";
	echo "<li><a href='". $PHP_SELF ."?etape=supprimer'>Supprimer un site SPIP</a> (n/d)</li>\n";
	echo "<li><a href='". $PHP_SELF ."?etape=motsclefs'>Synchroniser des mots-clefs</a></li>\n";
	echo "<li><a href='". $PHP_SELF ."?etape=reconf'>Administrer spip-clône</a></li>\n";
	echo "</ul>\n";

	"<p>Pour consulter les informations sur les sites cr&eacute;&eacute;s avec cet
		outil, choisir un ou plusieurs &eacute;l&eacute;ments de la liste suivant, puis cliquer
		sur le bouton 'consulter':</p>\n";

	// liste de sites clones existants
	$modules = get_all_clones();
	$modules_renommes = array();

	while (list($idl, $val) = each($modules)) {
		// résultat: "[nom_fichier] Nom Site (Création - Expiration)"
		$modules_renommes[$idl] = $val['clone_site_nom'] . " (" 
			. $val['clone_date_creation'] . " - " .  $val['clone_date_expiration'] . ")";
	}

	$nb_modules = count($modules_renommes);
	if ($nb_modules > 0) {
		$opt_select = "ORDERED MULTIPLE SIZE='" . ($nb_modules < 7 ? 10 : 15) . "'";
		debut_html_form("form_consulter", "GET", "consulter");
		echo "<p>" . get_html_select("id[]", $modules_renommes, $opt_select) . "</p>\n";
		echo "<p align='right'>" . get_html_form_item("submit", "submit_valider", "Consulter") . "</p>\n";
		fin_html_form();
	} else {
		markup("p", "Il n'y a pas de modules.");
	}

	html_pied();
	exit;
}

else if ($etape == "creer") {
	html_tete("Création d'un nouveau clône");

	debut_html_form("form_creer", "POST", "creer2");

	include('inc/inc_clones.php');
	details_clone();

	fin_html_form();

	html_pied();
	exit;
}

else if ($etape == "creer2") {
	html_tete("Création d'un nouveau clône, étape 2");

	// --- Contenu du fichier data/clone_NOM.php
	$texte = "<?php \n\n\$clone = array (\n\n";

	$texte .= "\"clone_site_nom\" => \"" . texte_script($site_nom) . "\",\n";
	$texte .= "\"clone_site_url\" => \"" . texte_script($site_url) . "\",\n";
	$texte .= "\"clone_date_creation\" => \"" . texte_script($date_creation) .  "\",\n"; // XXX valider ?
	$texte .= "\"clone_date_expiration\" => \"" . texte_script($date_expiration) .  "\",\n";
	$texte .= "\"clone_contact_nom\" => \"" . texte_script($contact_nom) .  "\",\n";
	$texte .= "\"clone_contact_courriel\" => \"" .  texte_script($contact_courriel) .  "\",\n";
	$texte .= "\"clone_path_src\" => \"" . texte_script($path_src) . "\",\n";
	$texte .= "\"clone_path_dest\" => \"" . texte_script($path_dest) . "\",\n";
	$texte .= "\"clone_squelette\" => \"" .  nettoyer_varsimple($select_squelettes) . "\",\n";
	$texte .= "\"clone_notes\" => \"" . texte_script($clone_notes) . "\",\n";
	$texte .= "\"clone_owner\" => \"" . nettoyer_varsimple($unixowner) . "\"\n";

	$texte .= ");\n\n?>\n";

	// --- nom de fichier dans data/clone_NOM.php
	$nom_fichier = creer_nom_unique_fichier_clone($site_url);

	$fclone = fopen($conf_dir_clones . '/' . $nom_fichier, "w");
	if (! $fclone) {
		msg_erreur("Le fichier " . $conf_dir_clones . '/' . $nom_fichier . " ne peut être ouvert.");
		exit;
	}
	fwrite($fclone, $texte);
	fclose($fclone);

	// -- Contenu du fichier mes_fonctions.php3 (pour spip_clone.sh)
	$texte = "<?php \n\n" . $mes_fonctions . "\n\n?>\n";

	if ($unixowner) {
		$apacheuser = nettoyer_varsimple(shell_exec('whoami'));
		$unixowner = ($conf_unixowner ? $conf_unixowner : $apacheuser);
		$unixowner = nettoyer_varsimple($unixowner);
	
		// Si le propriétaire unix du site créé n'est pas le serveur web
		// alors il faut utiliser sudo(1) pour lancer un chown(1).
		$my_sudo = ($unixowner == $apacheuser ? "" : "sudo ");
	} else {
		$my_sudo = "";
	}

	$my_debug = ($select_debug ? "SPIP_DEBUG=OUI" : "");
	$my_db = "SPIP_NODB=OUI"; // For now XXX
	$my_path = getcwd();
	$my_exec = $my_debug . " " . $my_db . " " . $my_sudo
			. $my_path . "/spip_clone/spip_clone.sh " 
			. $path_src . " " 
			. $path_dest . " "
			. $conf_spipsquels . $select_squelettes . " 2>&1";


	if ($my_sudo) {
		echo "<ul>";
		echo "<li>Lancement du script shell. Commande = (<code>" . $my_exec .  "</code>)</li>\n";
		echo "</ul>\n";
		exec($my_exec, $output, $status);
	} else {
		include('inc/inc_clones.php');
		$output = creer_milliers_liens_symboliques($path_src, $path_dest);
		$output = creer_milliers_liens_symboliques($conf_spipsquels . '/' . $select_squelettes,
							$path_dest . '/squelettes/', '', $output);
	}

	// - Créer mes_fonctions.php3
	ecrire_fichier_php_si_possible($path_dest . '/mes_fonctions.php3', $mes_fonctions, $output);
	
	// - Créer mes_options.php3
	ecrire_fichier_php_si_possible($path_dest .  '/ecrire/mes_options.php3', $mes_options, $output);

	// ** Afficher le résultat **
	echo "<h3>Résultat</h3>\n";
	echo "<blockquote>Le résultat devrait être vide à moins que vous ayiez
		activé l'option <code>debug</code>.<br /><b>Légende&nbsp;:</b> 
		<code>A</code> = Avertissement, <code>D</code> = Débug</blockquote>\n";

	echo "<form action='/' method='get'>\n";
	echo "<textarea readonly='readonly' cols='80' rows='10' dir='ltr'>\n";

	foreach($output as $outputline)
		echo("$outputline\n");

	echo "</textarea>\n</form>\n\n";

	// ** Conclure **
	if ($my_sudo) {
		echo "<ul>\n";
		echo "<li>Script shell terminé (" . ($status ? "erreur" : "succes") . ")</li>\n";
		echo "</ul>\n";
	}

	echo "<h3>Suite ...</h3>\n";

	echo "<ul>";
	echo "<li>Créer un compte pour la base de données?</li>\n";
	echo "<li>Consulter/modifier le fichier "
		. "<a href='spip_clone.php?etape=mes_fonctions&amp;site=$nom_fichier'>mes_fonctions.php3</a>?</li>\n";
	echo "<li>Consulter/modifier le fichier "
		. "<a href='spip_clone.php?etape=mes_options&amp;site=$nom_fichier'>ecrire/mes_options.php3</a>?</li>\n";
	echo "<li><a href='spip_clone.php'>Retourner &agrave; la page d'accueil.</a></li>";
	echo "</ul>\n";
	
	echo "<p>Le site '" . $site_nom . "' devrait être accessible à l'adresse suivante: "
		. "<a href='" . $site_url . "/ecrire/'>" . $site_url .  "/ecrire/</a>.</p>";
	
	html_pied();
	exit;
}

else if ($etape == "consulter") {
	html_tete("Informations");

	if (empty($id)) {
		echo "<P>Vous devez sélectionner un élément à consulter.</P>\n";
		exit;
	}

	debut_html_form("form_consulter", "POST", "consulter_FIXME");
	include('inc/inc_clones.php');

	while (list($idl, $val) = each($id)) {
		$my_clone = get_clone($val);

		details_clone($my_clone);
	}

	fin_html_form();

	html_pied();
	exit;
}

else if ($etape == "maj") {
	html_tete("Mise &agrave; jour");

	// liste de sites clones existants
	$modules = get_all_clones();
	$modules_renommes = array();

	while (list($idl, $val) = each($modules)) {
		// résultat: "<a href="..">Nom Site</a> (Création - Expiration)"
		$modules_renommes[$idl] = $val['clone_site_nom'] . " (" 
			. $val['clone_date_creation'] . " - " .  $val['clone_date_expiration'] . ")";
	}

	$nb_modules = count($modules_renommes);
	if ($nb_modules > 0) {
		debut_html_form("form_maj", "GET", "maj2");
		markup("p", get_html_checkbox("id[]", $modules_renommes, $opt_select));
		markup("p", get_html_form_item("submit", "submit_valider", "Lancer la mise &agrave; jour"), "", "text-align: center;");
		fin_html_form();
	} else {
		markup("p", "Il n'y a pas de modules.");
	}

	html_pied();
	exit;
}

else if ($etape == "maj2") {
	html_tete("Mise &agrave; jour");

	foreach ($indices as $site) {
		echo "<p>$site</p>\n";
		$my_clone = get_clone($site);

		// Petite horreur car je suis vraiment très pressé
		$unixowner = $my_clone['clone_owner'];
		$path_src = $my_clone['clone_path_src'];
		$path_dest = $my_clone['clone_path_dest'];
		$select_squelettes = $my_clone['clone_squelette'];

		if ($unixowner) {
			$apacheuser = nettoyer_varsimple(shell_exec('whoami'));
			$unixowner = ($conf_unixowner ? $conf_unixowner : $apacheuser);
			$unixowner = nettoyer_varsimple($unixowner);
		
			// Si le propriétaire unix du site créé n'est pas le serveur web
			// alors il faut utiliser sudo(1) pour lancer un chown(1).
			$my_sudo = ($unixowner == $apacheuser ? "" : "sudo ");
		} else {
			$my_sudo = "";
		}
	
		$my_debug = ($select_debug ? "SPIP_DEBUG=OUI" : "");
		$my_db = "SPIP_NODB=OUI"; // For now XXX
		$my_path = getcwd();
		$my_exec = $my_debug . " " . $my_db . " " . $my_sudo
				. $my_path . "/spip_clone/spip_clone.sh " 
				. $path_src . " " 
				. $path_dest . " "
				. $conf_spipsquels . $select_squelettes . " 2>&1";
	
		echo "<li>Lancement du script shell. Commande = (<code>" . $my_exec .  "</code>)</li>\n";
		exec($my_exec, $output, $status);
	
		// afficher le résultat 
		markup("li", "Affichage du résultat..");
		echo "</ul>\n";
		echo "<form action='/' method='get'><textarea readonly='readonly' cols='90' rows='15' dir='ltr'>\n";
		foreach($output as $outputline){
			echo("$outputline\n");
		}
		echo "</textarea></form>\n\n";
		echo "<ul>\n";
	}

	html_pied();
	exit;
}

else if ($etape == "motsclefs") {
	html_tete("Synchronisation de mots-clefs");

	if (! $spip_actif) {
		markup("p", "Vous devez installer et configurer un SPIP de référence
			avant de pouvoir propager les mots-clefs.");
	}

	debut_html_form("form_motclefs", 'post', 'motsclefs2');
	echo "<blockquote><b>Première étape:</b> choisir les mots-clés à synchroniser.
		À l'étape suivante vous pourrez choisir vers quels sites les
		synchroniser.</blockquote>\n";

	echo "<h3>Groupes de mots-clés à propager</h3>\n";

	echo "<ul class='discret'>";

	$result = spip_query("SELECT id_groupe, titre FROM spip_groupes_mots");
	while($row = spip_fetch_array($result)) {
		echo "<li class='boite'>"
			. "<input type='checkbox' id='groupe_" . $row['id_groupe'] . "' "
			. " name='motsclefs[]' value='" . $row['id_groupe'] . "' />"
			. "<label for='groupe_" .  $row['id_groupe'] . "'>"
			.	 $row['id_groupe'] . ": " . $row['titre']
			, "</label>\n";

		$result2 = spip_query("SELECT id_mot, titre FROM spip_mots WHERE id_groupe = " . $row['id_groupe']);
		echo "<ul>";
		while ($row2 = spip_fetch_array($result2)) {
			echo "<li>" . $row2['id_mot'] . ", " . $row2['titre'] . "</p>\n";
		}
		echo "</ul>\n";

		echo "</li>\n";
	}

	echo "<h3>Détection de doublons</h3>\n";

	echo "<blockquote>Il est possible que les mots-clés à créer existent déjà.
		Par quelle méthode détecter les doublons?</blockquote>\n";

	echo "<ul>";

	echo "<li class='discret'>";
	echo "<input type='radio' checked='checked' name='detection_doublons' id='detection_doublons_2' value='par_titre' />";
	echo "<label for='detection_doublons_2'>Selon le titre du groupe de mots-clés.</label></li>\n";

	echo "<li class='discret'>";
	echo "<input type='radio' name='detection_doublons' id='detection_doublons_1' value='par_id' />";
	echo "<label for='detection_doublons_1'>Selon le ID du groupe de mots-clés.</label></li>\n";

	echo "</ul>\n";

	markup("p", get_html_form_item("submit", "submit_valider", "Valider"), "", "text-align: center;");

	fin_html_form();
	html_pied();
	exit;
}

else if ($etape == "motsclefs2") {
	html_tete("Synchronisation de mots-clefs - &Eacute;tape 2");

	debut_html_form("form_motclefs2", 'post', 'motsclefs3');

	foreach ($motsclefs as $mot)
		echo "\t<input type='hidden' id='groupe_$mot' name='motsclefs[]' value='$mot' />\n";

	echo "\t<input type='hidden' id='detection_doublons' name='detection_doublons' value='$detection_doublons' />\n\n";

	$query = "SELECT id_groupe, titre 
				FROM spip_groupes_mots
				WHERE id_groupe IN (" . implode(",", $motsclefs) . ")";

	$result = spip_query($query);
	echo "<h3>Groupes de mots-clefs s&eacute;lectionn&eacute;s</h3>\n";
	echo "<ul>";

	while ($row = spip_fetch_array($result)) {
		echo "\t<li>" . $row['id_groupe'] . ": " . $row['titre'] . "</li>\n";
	}

	echo "</ul>\n";
	echo "<p>La d&eacute;tection de doublon se fera: " . $detection_doublons . "</p>\n";

	echo "<h3>Propager les mots-clefs vers...</h3>\n";

	// liste de sites clones existants
	$modules = get_all_clones();
	$modules_renommes = array();

	while (list($idl, $val) = each($modules)) {
		// résultat: "<a href="..">Nom Site</a> (Création - Expiration)"
		$modules_renommes[$idl] = $val['clone_site_nom'] . " (" 
			. $val['clone_date_creation'] . " - " .  $val['clone_date_expiration'] . ")";
	}

	$nb_modules = count($modules_renommes);
	if ($nb_modules > 0) {
		markup("p", get_html_checkbox("sites[]", $modules_renommes, $opt_select));
		markup("p", get_html_form_item("submit", "submit_valider", "Valider"), "", "text-align: center;");
	} else {
		markup("p", "Il n'y a pas de modules.");
	}

	fin_html_form();
	html_pied();

	exit;
}

else if ($etape == "motsclefs3") {
	html_tete("Synchronisation de mots-clefs - &Eacute;tape 3");

	debut_html_form("form_motclefs3", 'post', 'motsclefs4');

	include('inc/inc_motsclefs.php');
	$groupes = prendre_tout_sur_motsclefs($motsclefs);

	// Se connecter à chaque site et insérer les mots-clefs
	foreach ($sites as $site) {
		$log = inserer_groupe_dans_site($site, $groupes);

		if ($log)
			echo "<p><b>Avertissement de inserer_groupe_dans_site pour $site:</b></p> $log\n";
	}

	echo "<p><b>Termin&eacute;!</b> Vous pouvez retourner &agrave;
		la <a href='spip_clone.php'>page principale</a>.</p>\n";

	fin_html_form();
	html_pied();

	exit;
}

else if ($etape == "supprimer") {
	html_tete("Supprimer un site");

	markup("p", "Cette fonction n'est pas encore prête. N'hésitez pas à contribuer au code si ça vous intéresse!");

	html_pied();
	exit;
}

markup("p", "Erreur interne (possiblement &agrave; cause d'une mauvaise &eacute;tape).");

exit;

?>
